Sophie

Sophie

distrib > Mandriva > 2010.1 > x86_64 > by-pkgid > b37503e09ea539176fa3a2506fa8882d > files > 43

initscripts-8.99-16.1mdv2010.2.x86_64.rpm

#!/bin/bash
#
# netfs         Mount network filesystems.
#
# Authors:	Bill Nottingham <notting@redhat.com>
#		AJ Lewis <alewis@redhat.com>
# 		Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
#
# chkconfig: 345 25 75
# description: Mounts and unmounts all Network File System (NFS), \
#	       CIFS (Lan Manager/Windows), and NCP (NetWare) mount points.
#
### BEGIN INIT INFO
# Provides: $remote_fs
# Required-Start: $network
# Should-Start: $portmap nfs-common
# Required-Stop: $network
# Should-Stop: $portmap nfs-common
# Default-Start: 3 4 5
# Short-Description: Mount network filesystems.
# Description: Mounts and unmounts all Network File System (NFS),
#	       SMB/CIFS (Lan Manager/Windows), and NCP (NetWare) mount points.
### END INIT INFO

[ -f /etc/sysconfig/network ] || exit 0
. /etc/init.d/functions
. /etc/sysconfig/network

NFSFSTAB=$(LC_ALL=C awk '!/^#/ && $3 ~ /^nfs/ && $3 != "nfsd" && $4 !~ /noauto/ { print $2 }' /etc/fstab)
CIFSFSTAB=$(LC_ALL=C awk '!/^#/ && $3 == "cifs" && $4 !~ /noauto/ { print $2 }' /etc/fstab)
NCPFSTAB=$(LC_ALL=C awk '!/^#/ && $3 == "ncpfs" && $4 !~ /noauto/ { print $2 }' /etc/fstab)
NETDEVFSTAB=$(LC_ALL=C awk '!/^#/ && $4 ~/_netdev/ && $4 !~ /noauto/ { print $1 }' /etc/fstab)

NFSMTAB=$(LC_ALL=C awk '$3 ~ /^nfs/ && $3 != "nfsd" && $2 != "/" { print $2 }' /proc/mounts)
CIFSMTAB=$(LC_ALL=C awk '$3 == "cifs" { print $2 }' /proc/mounts)
NCPMTAB=$(LC_ALL=C awk '$3 == "ncpfs" { print $2 }' /proc/mounts)
NETDEVMTAB=$(LC_ALL=C awk '$4 ~ /_netdev/ && $2 != "/" { print $2 }' /etc/mtab)

# See how we were called.
case "$1" in
  start)
        [ ! -f /var/lock/subsys/network -a ! -f /var/lock/subsys/NetworkManager ] && exit 0
        [ -n "$NFSFSTAB" ] && 
	  {
	    action "Mounting NFS filesystems: " mount -a -t nfs,nfs4
	  }
        [ -n "$CIFSFSTAB" ] && action "Mounting CIFS filesystems: " mount -a -t cifs
        [ -n "$NCPFSTAB" ] && action "Mounting NCP filesystems: " mount -a -t ncpfs
        [ -n "$NETDEVFSTAB" ] &&
	  {
	    if [ -f /etc/mdadm.conf ]; then
		mdadm -A -s
	    fi
	    if [ -f /etc/multipath.conf -a -x /sbin/multipath ]; then
	    	modprobe dm-multipath >/dev/null 2>&1
		/sbin/multipath -v 0
		if [ -x /sbin/kpartx ]; then
		       /sbin/dmsetup ls --target multipath --exec "/sbin/kpartx -a -p p"
		fi
	    fi
	    if [ -x /sbin/lvm ]; then
		if /sbin/lvm vgscan > /dev/null 2>&1 ; then
		       action "Setting up Logical Volume Management:" /sbin/lvm vgchange -a y
		fi
	    fi
	    STRING=`gprintf "Checking network-attached filesystems"`
	    
	    echo $STRING
	    fsck -A -T -R -a -t opts=_netdev
	    rc=$?
	    
	    if [ "$rc" -eq "0" ]; then
	    	success "$STRING"
		echo
	    elif [ "$rc" -eq "1" ]; then
	        passed "$STRING"
	        echo
	    fi
	    
	    if [ "$rc" -gt 1 ]; then
		if [ -x /usr/bin/plymouth ] && /usr/bin/plymouth --ping ; then
			/usr/bin/plymouth --hide-splash
		fi
		failure "$STRING"
		tty >/dev/null 2>&1 || exit 1
		echo
		echo
		gprintf "*** An error occurred during the file system check.\n"
		gprintf "*** Dropping you to a shell; the system will reboot\n"
		gprintf "*** when you leave the shell.\n"
		
		str=`gprintf "(Repair filesystem)"`
		PS1="$str \# # "; export PS1
		[ "$SELINUX" = "1" ] && disable_selinux
		sulogin
		
		shutdown -r now
	   fi
	  }
	touch /var/lock/subsys/netfs
	action "Mounting other filesystems: " mount -a -t nonfs,nfs4,cifs,ncpfs,gfs -O noencrypted
	;;
  stop)
        # Unmount loopback stuff first
	__umount_loopback_loop
  	if [ -n "$NETDEVMTAB" ]; then
		__umount_loop '$4 ~ /_netdev/ && $2 != "/" {print $2}' \
			/etc/mtab \
			"Unmounting network block filesystems: " \
			"Unmounting network block filesystems (retry): "
	fi
  	if [ -n "$NFSMTAB" ]; then
		__umount_loop '$3 ~ /^nfs/ && $3 != "nfsd" && $2 != "/" {print $2}' \
			/proc/mounts \
			"Unmounting NFS filesystems: " \
			"Unmounting NFS filesystems (retry): " \
			"-f -l"
	fi
	[ -n "$CIFSMTAB" ] && action "Unmounting CIFS filesystems: " umount -a -t cifs
	[ -n "$NCPMTAB" ] && action "Unmounting NCP filesystems: " umount -a -t ncp,ncpfs
	rm -f /var/lock/subsys/netfs
	;;
  status)
	if [ -f /proc/mounts ] ; then
	        [ -n "$NFSFSTAB" ] && {
		     gprintf "Configured NFS mountpoints: \n"
		     for fs in $NFSFSTAB; do echo $fs ; done
		}
	        [ -n "$CIFSFSTAB" ] && {
		     gprintf "Configured CIFS mountpoints: \n"
		     for fs in $CIFSFSTAB; do echo $fs ; done
		}
	        [ -n "$NCPFSTAB" ] && {
		     gprintf "Configured NCP mountpoints: \n"
		     for fs in $NCPFSTAB; do echo $fs ; done
		}
		[ -n "$NETDEVFSTAB" ] && {
		      gprintf "Configured network block devices: \n"
		      for fs in $NETDEVFSTAB; do echo $fs ; done
		}
		[ -n "$NFSMTAB" ] && {
                      gprintf "Active NFS mountpoints: \n"
		      for fs in $NFSMTAB; do echo $fs ; done
		}
		[ -n "$CIFSMTAB" ] && {
                      gprintf "Active CIFS mountpoints: \n"
		      for fs in $CIFSMTAB; do echo $fs ; done
		}
		[ -n "$NCPMTAB" ] && {
                      gprintf "Active NCP mountpoints: \n"
		      for fs in $NCPMTAB; do echo $fs ; done
		}
		[ -n "$NETDEVMTAB" ] && {
		      gprintf "Active network block devices: \n"
		      for fs in $NETDEVMTAB; do echo $fs ; done
		}
	else
		gprintf "/proc filesystem unavailable\n"
	fi
	[ -r /var/lock/subsys/netfs ] || exit 2
	;;
  restart)
	$0 stop
	$0 start
	;;
  reload)
        $0 start
	;;
  *)
	gprintf "Usage: %s\n" "$(basename $0) {start|stop|restart|reload|status}"
	exit 1
esac

exit 0